<template>
	<div class="bg-darkgray rounded p-5 ml-5 text-white">
		<h2 class="text-2xl">Configuration engine settings</h2>
		<div class="mt-5 flex flex-col">
			<form-input v-for="field in fields" :field="field" :key="field.key"></form-input>
		</div>
		<div class="animate__animated animate__fadeInRight p-5 mt-5" :class="validationClass" v-if="engine_validation.status">
			<pre class="font-body">{{ engine_validation.message }}</pre>
		</div>
	</div>
</template>

<script>
import settings_fields from "../../settings_fields";
import FormInput from "./FormInput";
import {mapActions, mapGetters, mapMutations} from "vuex";

export default {
	name: "Engine",
	computed: {
		...mapGetters('config', [
			'engine_config',
			'engine_validation'
		]),
		fields: () => settings_fields.Engine,
		validationClass(){
			return {
				'bg-error text-white': this.engine_validation.status !== 'success',
				'bg-blue-gradient text-white': this.engine_validation.status === 'success'
			}
		},
	},
	watch:{
		engine_config(config){
			this.validateEngine();
		}
	},
	methods: {
		...mapMutations('config', [
			'validation_set'
		]),
		...mapActions('config', [
			'validateEngine'
		])
	},
	mounted() {
		this.validateEngine();
	},
	components: {
		FormInput
	}
}
</script>

<style scoped>

</style>